VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmFolderTree 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Building Folder Tree with xDir"
   ClientHeight    =   6825
   ClientLeft      =   2040
   ClientTop       =   1335
   ClientWidth     =   7545
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   6825
   ScaleWidth      =   7545
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.ImageList ImageList1 
      Left            =   6120
      Top             =   840
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   8421376
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   2
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "FolderTree.frx":0000
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "FolderTree.frx":0552
            Key             =   ""
         EndProperty
      EndProperty
   End
   Begin MSComctlLib.ProgressBar ProgressBar1 
      Height          =   315
      Left            =   1440
      TabIndex        =   7
      Top             =   6180
      Visible         =   0   'False
      Width           =   6015
      _ExtentX        =   10610
      _ExtentY        =   556
      _Version        =   393216
      BorderStyle     =   1
      Appearance      =   0
   End
   Begin VB.CheckBox chkProgress 
      Caption         =   "progress bar"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   6180
      Width           =   1215
   End
   Begin VB.Frame Frame1 
      Height          =   1095
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   5775
      Begin VB.CheckBox chkSorted 
         Caption         =   "sorted"
         Height          =   195
         Left            =   4740
         TabIndex        =   9
         Top             =   720
         Value           =   1  'Checked
         Width           =   735
      End
      Begin VB.CheckBox chkInclRootFldr 
         Caption         =   "include the root folder"
         Height          =   315
         Left            =   2760
         TabIndex        =   8
         Top             =   660
         Value           =   1  'Checked
         Width           =   2115
      End
      Begin VB.CheckBox chkShowFullPath 
         Caption         =   "show full path"
         Height          =   315
         Left            =   1260
         TabIndex        =   5
         Top             =   660
         Width           =   1395
      End
      Begin VB.CheckBox chkWithFiles 
         Caption         =   "with files"
         Height          =   315
         Left            =   120
         TabIndex        =   4
         Top             =   660
         Width           =   1035
      End
      Begin xDir200_Demo.SelFolder SelFolder1 
         Height          =   315
         Left            =   120
         TabIndex        =   10
         Top             =   240
         Width           =   5355
         _ExtentX        =   8176
         _ExtentY        =   556
         SavingApp       =   "xDir200_Demo"
         SavingKey       =   "FolderTree"
      End
   End
   Begin VB.CommandButton cmdBuild 
      Caption         =   "Build Tree"
      Height          =   555
      Left            =   6120
      TabIndex        =   2
      Top             =   240
      Width           =   1215
   End
   Begin MSComctlLib.StatusBar StatusBar1 
      Align           =   2  'Align Bottom
      Height          =   315
      Left            =   0
      TabIndex        =   0
      Top             =   6510
      Width           =   7545
      _ExtentX        =   13309
      _ExtentY        =   556
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
         NumPanels       =   2
         BeginProperty Panel1 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
         EndProperty
         BeginProperty Panel2 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
         EndProperty
      EndProperty
   End
   Begin MSComctlLib.TreeView TreeView1 
      Height          =   4695
      Left            =   120
      TabIndex        =   1
      Top             =   1380
      Width           =   7275
      _ExtentX        =   12832
      _ExtentY        =   8281
      _Version        =   393217
      Indentation     =   406
      LineStyle       =   1
      Style           =   7
      ImageList       =   "ImageList1"
      Appearance      =   1
   End
End
Attribute VB_Name = "frmFolderTree"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Implements IXDFoundItemEx

Private Sub chkProgress_Click()
   ProgressBar1.Visible = chkProgress
End Sub

Private Sub cmdBuild_Click()
   Dim xd As New xDir
   Dim nCount As Long
   
   If Not gfbDirExists(SelFolder1.Path) Then Exit Sub
   
   xd.RootFolder = SelFolder1.Path
   xd.ItemTypes = xditFolder + IIf(chkWithFiles, xditFile, 0)
   xd.EnumRootFolder = CBool(chkInclRootFldr.Value)
   
   StatusBar1.Panels(2).Text = ""
   
   If chkProgress Then
      StatusBar1.Panels(1).Text = "Counting number of items..."
      ProgressBar1.Value = 0
      xd.SortType = xdstNone ' to speed up the next statement
      nCount = xd.ProcessFolder()
      If nCount > 0 Then
         ProgressBar1.Max = nCount
      Else
         MsgBox "Nothing to enumerate!", vbCritical, Me.Caption
         Exit Sub
      End If
   End If
   
   StatusBar1.Panels(1).Text = "Removing items from TreeView..."
   TreeView1.Nodes.Clear
   
   StatusBar1.Panels(1).Text = "Building the tree..."
   LockWindowUpdate TreeView1.hwnd
   
   ' The previous issue of ProcessFolder don't use this setting
   ' to increase the performance
   xd.SortType = IIf(chkSorted.Value, xdstTree, xdstNone)
   
   t1 = GetTickCount
   
   nCount = xd.ProcessFolder(Me)
   
   t2 = GetTickCount
   
   LockWindowUpdate 0
   StatusBar1.Panels(1).Text = "Completed in " & t2 - t1 & " msec."
   StatusBar1.Panels(2).Text = "Found " & nCount & " items"
End Sub

Private Sub Form_Load()
   StatusBar1.Panels(1).Width = StatusBar1.Width \ 2
   StatusBar1.Panels(2).Width = StatusBar1.Width \ 2
End Sub

Private Sub IXDFoundItemEx_Proc(ParentFullPath As String, ItemName As String, ByVal ItemType As xDir200_75B4A91C.EItemTypes, ByVal Attributes As xDir200_75B4A91C.EItemAttributes, FileSize As Variant, Created As Date, Modified As Date, Accessed As Date, ByVal NodeKey As Long, ByVal ParentNodeKey As Long, CancelEnum As Boolean, ByVal UserValue As Long)
   If ParentNodeKey = 0 Then
      TreeView1.Nodes.Add _
         Text:=IIf(chkShowFullPath, ParentFullPath & ItemName, ItemName), _
         Key:="K" & NodeKey, _
         Image:=IIf(ItemType = xditFolder, 1, 2)
   Else
      TreeView1.Nodes.Add _
         Text:=IIf(chkShowFullPath, ParentFullPath & ItemName, ItemName), _
         Key:="K" & NodeKey, _
         Relative:="K" & ParentNodeKey, _
         Relationship:=tvwChild, _
         Image:=IIf(ItemType = xditFolder, 1, 2)
   End If
   
   If chkProgress Then
      ProgressBar1.Value = ProgressBar1.Value + 1
   End If
End Sub
